=== doc/Makefile ===
L4DIR	?= ..

TARGET = bid-spec bid-tut building-howto dev-overview l4env-concept html

doc: $(TARGET)
html: bid-spec bid-tut building-howto dev-overview

include $(L4DIR)/mk/subdir.mk
