=== doc/html/Makefile ===
L4DIR = ../..
include $(L4DIR)/mk/Makeconf

HEADER ?= header.html
FOOTER ?= footer.html
INDEX  ?= $(OBJ_DIR)/index.html

TITLES ?= $(sort $(wildcard $(OBJ_DIR)/*.title))
TITLELIST ?= $(OBJ_DIR)/titles.list

all:: $(INDEX)

$(INDEX): $(HEADER) $(FOOTER) Makefile $(TITLES) $(TITLELIST) generate_index.pl
	./generate_index.pl $(INDEX) $(HEADER) $(FOOTER) $(TITLES)

-include $(OBJ_DIR)/titles.list
# new files or old ones disappeared?
ifneq ($(OLDTITLES),$(TITLES))
.PHONY: $(TITLELIST)
endif

$(TITLELIST):
	echo "OLDTITLES = $(TITLES)" >$@

install:

clean:
	rm -rf $(TITLELIST) $(INDEX)

cleanall: clean
	rm -rf $(TITLES) $(TITLES:.title=)
