=== doc/manpages/debian/control ===
Source: manpages-drops
Section: doc
Priority: optional
Maintainer: Adam Lackorzynski <adam@os.inf.tu-dresden.de>
Build-Depends: debhelper (>> 3.0.0)
Standards-Version: 3.6.1

Package: manpages-drops
Architecture: all
Depends: 
Description: Manpages of the DROPS project
 This package contains the manpages of the DROPS project. It can be
 installed on your favourite Debian box to ease developing.
